#pragma once

// Add the following line to one of the .cpp files:
// IMPLEMENT_DYNCREATE(CZetServerCtrl, CWnd)

class CZetServerCtrl : public CWnd
{
protected:
	DECLARE_DYNCREATE(CZetServerCtrl)

public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0xF563E0CD, 0xC570, 0x411B, { 0xBE, 0x7E, 0x8C, 0x45, 0xA1, 0x70, 0x28, 0x95 } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle,
						const RECT& rect, CWnd* pParentWnd, UINT nID, 
						CCreateContext* pContext = NULL)
	{
		return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); 
	}

	BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, 
				UINT nID, CFile* pPersist = NULL, BOOL bStorage = FALSE,
				BSTR bstrLicKey = NULL)
	{
		return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); 
	}

public:
	void AboutBox()
	{
		InvokeHelper(DISPID_ABOUTBOX, DISPATCH_METHOD, VT_EMPTY, NULL, NULL);
	}
	long PointAllInfo(LPDISPATCH * point)
	{
		long result;
		static BYTE parms[] = VTS_PDISPATCH;
		InvokeHelper(0x1, DISPATCH_METHOD, VT_I4, (void*)&result, parms, point);
		return result;
	}
	long Connect()
	{
		long result;
		InvokeHelper(0x2, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long Disconnect()
	{
		long result;
		InvokeHelper(0x3, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	float Frequency(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x4, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	long BufferSize()
	{
		long result;
		InvokeHelper(0x5, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long NullPointer(long channel, long decade)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, decade);
		return result;
	}
	long QuanChan()
	{
		long result;
		InvokeHelper(0x7, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long Pointer(long channel, long decade)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, decade);
		return result;
	}
	CString Commentary(long channel)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x9, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, channel);
		return result;
	}
	CString Conversion(long channel)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xa, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, channel);
		return result;
	}
	float MaxLevel(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xb, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	float MinLevel(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xc, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	float Reference(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xd, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	float CurLevel(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0xe, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	long PrusEna(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x17, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long TypeAdc(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x18, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long NumDSP(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x19, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long NumPhChan(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long NumFileUsed(long NumFile)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumFile);
		return result;
	}
	long SetSrvWin(LPUNKNOWN Hwnd)
	{
		long result;
		static BYTE parms[] = VTS_UNKNOWN;
		InvokeHelper(0x1c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Hwnd);
		return result;
	}
	long ConnectDac(long NumberDac)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumberDac);
		return result;
	}
	long DisconnectDac(long NumberDac)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x1e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumberDac);
		return result;
	}
	long TalkAbout(long Param, long Value)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x1f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Param, Value);
		return result;
	}
	double CurrentTime(long channel)
	{
		double result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x20, DISPATCH_METHOD, VT_R8, (void*)&result, parms, channel);
		return result;
	}
	long GetData(long channel, long decade, double time, long size, float * data)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_PR4;
		InvokeHelper(0x21, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, decade, time, size, data);
		return result;
	}
	long QuanDSP()
	{
		long result;
		InvokeHelper(0x22, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long QuanPhChan(long NumDSP)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x23, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumDSP);
		return result;
	}
	long PutData(long channel, double time, long size, float * data)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_I4 VTS_PR4;
		InvokeHelper(0x24, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, time, size, data);
		return result;
	}
	long DisconnectVrtCh()
	{
		long result;
		InvokeHelper(0x25, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long ConnectVrtCh(long NumChan)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x27, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumChan);
		return result;
	}
	float ShifLevel(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x28, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	CString AFCH(long channel)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x29, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, channel);
		return result;
	}
	long VrtChnInfo(long virtchannel, BSTR * comment, BSTR * Conversion, float freq, float MaxLevel, float MinLevel, float refer)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_PBSTR VTS_PBSTR VTS_R4 VTS_R4 VTS_R4 VTS_R4;
		InvokeHelper(0x2a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, virtchannel, comment, Conversion, freq, MaxLevel, MinLevel, refer);
		return result;
	}
	long NumModule(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x2b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long SetDigOutEnable(long Zmodule, long OutMask)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x2c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, OutMask);
		return result;
	}
	long GetDigOutEnable(long Zmodule)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x2d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule);
		return result;
	}
	long GetDigInput(long Zmodule)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x2e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule);
		return result;
	}
	long GetDigOutput(long Zmodule)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x2f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule);
		return result;
	}
	long SetDigOutput(long Zmodule, long DigOut)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x30, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, DigOut);
		return result;
	}
	float GetAttenuation(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x31, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	long SetAttenuation(long channel, float attenuator)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_R4;
		InvokeHelper(0x32, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, attenuator);
		return result;
	}
	long MaxQuanChanDac()
	{
		long result;
		InvokeHelper(0x33, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long IsFreeChanDac(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x34, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long SetChanDac(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x35, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long RemChanDac(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x36, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	long OrderConnected()
	{
		long result;
		InvokeHelper(0x37, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetPWMEnable(long Zmodule)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x38, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule);
		return result;
	}
	long SetFreqPWM(long Zmodule, long Rate, long Period)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x39, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, Rate, Period);
		return result;
	}
	long SetOnDutyPWM(long Zmodule, long channel, long OnDutyPWM, long ShiftPWM)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x3a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, channel, OnDutyPWM, ShiftPWM);
		return result;
	}
	long RegulatorPWM(long Zmodule, float * data, long size)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_PR4 VTS_I4;
		InvokeHelper(0x3b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, data, size);
		return result;
	}
	long StartPWM(long Zmodule, long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x3c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, channel);
		return result;
	}
	long StopPWM(long Zmodule, long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x3d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, channel);
		return result;
	}
	long IdChanDac(long channel, long * Id)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_PI4;
		InvokeHelper(0x3e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, Id);
		return result;
	}
	long IdChan(long channel, long * Id)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_PI4;
		InvokeHelper(0x3f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, Id);
		return result;
	}
	long IdChanVirt(long channel, long * Id)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_PI4;
		InvokeHelper(0x40, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, Id);
		return result;
	}
	float FrequencyDac(long channelDac)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x41, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channelDac);
		return result;
	}
	long GetDataVar(long channel, long decade, double time, long size, VARIANT * datvar)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_PVARIANT;
		InvokeHelper(0x42, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, decade, time, size, datvar);
		return result;
	}
	long GetDataNet(long channel, long decade, double time, long size, long pData)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4;
		InvokeHelper(0x43, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, decade, time, size, pData);
		return result;
	}
	long PutDataNet(long channel, double time, long size, long pData)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_R8 VTS_I4 VTS_I4;
		InvokeHelper(0x44, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel, time, size, pData);
		return result;
	}
	long WorkChanADC(long channel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x45, DISPATCH_METHOD, VT_I4, (void*)&result, parms, channel);
		return result;
	}
	float Sense(long channel)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x46, DISPATCH_METHOD, VT_R4, (void*)&result, parms, channel);
		return result;
	}
	long SetBitDigOutput(long Zmodule, long bit)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x47, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, bit);
		return result;
	}
	long ClrBitDigOutput(long Zmodule, long bit)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x48, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Zmodule, bit);
		return result;
	}
	CString GetDataGPS(long maxsize, long * realsize)
	{
		CString result;
		static BYTE parms[] = VTS_I4 VTS_PI4;
		InvokeHelper(0x49, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, maxsize, realsize);
		return result;
	}
	long PutDataGPS(LPCTSTR nmea, long size)
	{
		long result;
		static BYTE parms[] = VTS_BSTR VTS_I4;
		InvokeHelper(0x4a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, nmea, size);
		return result;
	}
	long IsFileGPS()
	{
		long result;
		InvokeHelper(0x4b, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long SetShiftGPS(float seconds)
	{
		long result;
		static BYTE parms[] = VTS_R4;
		InvokeHelper(0x4c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, seconds);
		return result;
	}
	float GetShiftGPS()
	{
		float result;
		InvokeHelper(0x4d, DISPATCH_METHOD, VT_R4, (void*)&result, NULL);
		return result;
	}
	double GetStartTime()
	{
		double result;
		InvokeHelper(0x4e, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
		return result;
	}
	long enaGPSync(long enable)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x4f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, enable);
		return result;
	}
	long advanceGPS(long seconds)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x50, DISPATCH_METHOD, VT_I4, (void*)&result, parms, seconds);
		return result;
	}
	long satGPS(long satinfo)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x51, DISPATCH_METHOD, VT_I4, (void*)&result, parms, satinfo);
		return result;
	}
	double WorkingTime()
	{
		double result;
		InvokeHelper(0x52, DISPATCH_METHOD, VT_R8, (void*)&result, NULL);
		return result;
	}
	CString GroupName(long channel)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x53, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, channel);
		return result;
	}
	long SetGroupName(long virtchannel, LPCTSTR GrName)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_BSTR;
		InvokeHelper(0x54, DISPATCH_METHOD, VT_I4, (void*)&result, parms, virtchannel, GrName);
		return result;
	}
	long SetTypeVirt(long virtchannel)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x55, DISPATCH_METHOD, VT_I4, (void*)&result, parms, virtchannel);
		return result;
	}
	float GetFrequency(long Modul)
	{
		float result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x56, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Modul);
		return result;
	}
	float SetFrequency(long Modul, float freq)
	{
		float result;
		static BYTE parms[] = VTS_I4 VTS_R4;
		InvokeHelper(0x57, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Modul, freq);
		return result;
	}
	float GetNextFreq(long Modul, long Par)
	{
		float result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x58, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Modul, Par);
		return result;
	}
	long OnOffChannel(long Modul, long channel, long Par)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x59, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Modul, channel, Par);
		return result;
	}
	long SetSinDiffChannel(long Modul, long channel, long Par)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_I4;
		InvokeHelper(0x5a, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Modul, channel, Par);
		return result;
	}
	long GetDigBits(long Modul)
	{
		long result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x5b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Modul);
		return result;
	}
	CString DacGroupName(long dacchannel)
	{
		CString result;
		static BYTE parms[] = VTS_I4;
		InvokeHelper(0x5c, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, dacchannel);
		return result;
	}
	long Triger(long Modul, long Parametr, long * ValInt, float * ValFloat)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4 VTS_PI4 VTS_PR4;
		InvokeHelper(0x5d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Modul, Parametr, ValInt, ValFloat);
		return result;
	}
	long SetStatus(long virtchannel, long status)
	{
		long result;
		static BYTE parms[] = VTS_I4 VTS_I4;
		InvokeHelper(0x69, DISPATCH_METHOD, VT_I4, (void *)&result, parms, virtchannel, status);
		return result;
	}
};
